Index: django/contrib/localflavor/au/models.py
===================================================================
--- django/contrib/localflavor/au/models.py	(revision 0)
+++ django/contrib/localflavor/au/models.py	(revision 0)
@@ -0,0 +1,43 @@
+from django.conf import settings
+from django.utils.translation import ugettext_lazy as _
+from django.db.models.fields import CharField
+from django.contrib.localflavor.au.au_states import STATE_CHOICES
+from django.contrib.localflavor.au import forms
+
+class AUStateField(CharField):
+
+    description = _("Australian State")
+
+    def __init__(self, *args, **kwargs):
+        kwargs['choices'] = STATE_CHOICES
+        kwargs['max_length'] = 3
+        super(AUStateField, self).__init__(*args, **kwargs)
+
+
+class AUPostCodeField(CharField):
+
+    description = _("Australian Postcode")
+
+    def __init__(self, *args, **kwargs):
+        kwargs['max_length'] = 4
+        super(AUPostCodeField, self).__init__(*args, **kwargs)
+
+    def formfield(self, **kwargs):
+        defaults = {'form_class': forms.AUPostCodeField}
+        defaults.update(kwargs)
+        return super(AUPostCodeField, self).formfield(**defaults)
+        
+        
+class AUPhoneNumberField(CharField):
+
+    description = _("Australian Phone number")
+
+    def __init__(self, *args, **kwargs):
+        kwargs['max_length'] = 20
+        super(AUPhoneNumberField, self).__init__(*args, **kwargs)
+
+    def formfield(self, **kwargs):
+        defaults = {'form_class': forms.AUPhoneNumberField}
+        defaults.update(kwargs)
+        return super(AUPhoneNumberField, self).formfield(**defaults)
+    
Index: django/contrib/localflavor/au/forms.py
===================================================================
--- django/contrib/localflavor/au/forms.py	(revision 12761)
+++ django/contrib/localflavor/au/forms.py	(working copy)
@@ -12,15 +12,22 @@
 PHONE_DIGITS_RE = re.compile(r'^(\d{10})$')
 
 class AUPostCodeField(RegexField):
-    """Australian post code field."""
+    """ Australian post code field.
+
+    Assumed to be 4 digits.
+    Northern Territory 3-digit postcodes should have leading zero.
+    """
     default_error_messages = {
-        'invalid': _('Enter a 4 digit post code.'),
+        'invalid': _('Enter a 4 digit postcode.'),
     }
 
     def __init__(self, *args, **kwargs):
+        if 'max_length' in kwargs:
+            kwargs.pop('max_length')
         super(AUPostCodeField, self).__init__(r'^\d{4}$',
-            max_length=None, min_length=None, *args, **kwargs)
+            max_length=4, min_length=None, *args, **kwargs)
 
+        
 class AUPhoneNumberField(Field):
     """Australian phone number field."""
     default_error_messages = {
@@ -40,6 +47,7 @@
             return u'%s' % phone_match.group(1)
         raise ValidationError(self.error_messages['invalid'])
 
+    
 class AUStateSelect(Select):
     """
     A Select widget that uses a list of Australian states/territories as its
Index: tests/regressiontests/localflavor/tests.py
===================================================================
--- tests/regressiontests/localflavor/tests.py	(revision 12761)
+++ tests/regressiontests/localflavor/tests.py	(working copy)
@@ -1,7 +1,12 @@
 from django.test import TestCase
 from models import Place
-from forms import PlaceForm
+from forms import PlaceForm, AustralianPlaceForm
+import re
 
+SELECTED_OPTION_PATTERN = r'<option value="%s" selected="selected">'
+BLANK_OPTION_PATTERN = r'<option value="">'
+INPUT_VALUE_PATTERN = r'<input[^>]*value="%s"[^>]*>'
+
 class USLocalflavorTests(TestCase):
     def setUp(self):
         self.form = PlaceForm({'state':'GA', 'state_req':'NC', 'name':'impossible'})
@@ -81,3 +86,53 @@
 <option value="WY">Wyoming</option>
 </select>"""
         self.assertEqual(str(self.form['state']), state_select_html)
+
+        
+class AULocalflavorTests(TestCase):
+    def setUp(self):
+        self.form = AustralianPlaceForm(
+            {'state':'WA',
+             'state_required':'QLD',
+             'name':'dummy',
+             'postcode':'1234',
+             'postcode_required':'4321',
+             })
+        
+    def test_get_display_methods(self):
+        """ Ensure get_*_display() methods are added to model instances. """
+        place = self.form.save()
+        self.assertEqual(place.get_state_display(), 'Western Australia')
+        self.assertEqual(place.get_state_required_display(), 'Queensland')
+
+    def test_default_values(self):
+        """ Ensure that default values are selected in forms. """
+        form = AustralianPlaceForm()
+        self.assertTrue(re.search(SELECTED_OPTION_PATTERN % 'NSW',
+                                  str(form['state_default'])))
+        self.assertTrue(re.search(INPUT_VALUE_PATTERN % '2500',
+                                  str(form['postcode_default'])))
+        
+    def test_required(self):
+        """ Test that required AUStateFields throw appropriate errors. """
+        form = AustralianPlaceForm({'state':'NSW', 'name':'Wollongong'})
+        self.assertFalse(form.is_valid())
+        self.assertEqual(
+            form.errors['state_required'], [u'This field is required.'])
+        self.assertEqual(
+            form.errors['postcode_required'], [u'This field is required.'])        
+    
+    def test_field_blank_option(self):
+        """ Test that the empty option is there. """
+        self.assertTrue(re.search(BLANK_OPTION_PATTERN,
+                                  str(self.form['state'])))
+
+    def test_selected_values(self):
+        """ Ensure selected states match the initial values provided. """
+        self.assertTrue(re.search(SELECTED_OPTION_PATTERN % 'WA',
+                                  str(self.form['state'])))
+        self.assertTrue(re.search(SELECTED_OPTION_PATTERN % 'QLD',
+                                  str(self.form['state_required'])))
+        self.assertTrue(re.search(INPUT_VALUE_PATTERN % '1234',
+                                  str(self.form['postcode'])))
+        self.assertTrue(re.search(INPUT_VALUE_PATTERN % '4321',
+                                  str(self.form['postcode_required'])))                
Index: tests/regressiontests/localflavor/models.py
===================================================================
--- tests/regressiontests/localflavor/models.py	(revision 12761)
+++ tests/regressiontests/localflavor/models.py	(working copy)
@@ -1,8 +1,19 @@
 from django.db import models
 from django.contrib.localflavor.us.models import USStateField
+from django.contrib.localflavor.au.models import AUStateField, AUPostCodeField
 
 class Place(models.Model):
     state = USStateField(blank=True)
     state_req = USStateField()
     state_default = USStateField(default="CA", blank=True)
     name = models.CharField(max_length=20)
+
+
+class AustralianPlace(models.Model):
+    state = AUStateField(blank=True)
+    state_required = AUStateField()
+    state_default = AUStateField(default="NSW", blank=True)
+    postcode = AUPostCodeField(blank=True)
+    postcode_required = AUPostCodeField()
+    postcode_default = AUPostCodeField(default="2500", blank=True)
+    name = models.CharField(max_length=20)
Index: tests/regressiontests/localflavor/forms.py
===================================================================
--- tests/regressiontests/localflavor/forms.py	(revision 12761)
+++ tests/regressiontests/localflavor/forms.py	(working copy)
@@ -1,7 +1,12 @@
 from django.forms import ModelForm
-from models import Place
+from models import Place, AustralianPlace
 
 class PlaceForm(ModelForm):
     """docstring for PlaceForm"""
     class Meta:
         model = Place
+
+class AustralianPlaceForm(ModelForm):
+    """ Form for storing an Australian place. """
+    class Meta:
+        model = AustralianPlace        
Index: docs/ref/contrib/localflavor.txt
===================================================================
--- docs/ref/contrib/localflavor.txt	(revision 12761)
+++ docs/ref/contrib/localflavor.txt	(working copy)
@@ -169,6 +169,21 @@
     A ``Select`` widget that uses a list of Australian states/territories as its
     choices.
 
+.. class:: au.models.AUPhoneNumberField
+
+    A model field that checks that the value is a valid Australian phone
+    number (ten digits).
+
+.. class:: au.models.AUStateField
+
+    A model field that forms represent as a ``forms.AUStateField`` field and
+    stores the three-letter Australian state abbreviation in the database.
+
+.. class:: au.models.AUPostCodeField
+
+    A model field that forms represent as a ``forms.AUPostCodeField`` field 
+    and stores the four-digit Australian postcode in the database.
+
 Austria (``at``)
 ================
 