diff --git a/django/db/models/base.py b/django/db/models/base.py
index a5c9986..30b12da 100644
--- a/django/db/models/base.py
+++ b/django/db/models/base.py
@@ -467,7 +467,7 @@ class Model(object):
             if pk_set:
                 # Determine whether a record with the primary key already exists.
                 if (force_update or (not force_insert and
-                        manager.filter(pk=pk_val).extra(select={'a': 1}).values('a').order_by())):
+                        manager.filter(pk=pk_val).exists())):
                     # It does already exist, so do an UPDATE.
                     if force_update or non_pks:
                         values = [(f, None, (raw and getattr(self, f.attname) or f.pre_save(self, False))) for f in non_pks]
diff --git a/django/db/models/manager.py b/django/db/models/manager.py
index 52612d8..73d2bf5 100644
--- a/django/db/models/manager.py
+++ b/django/db/models/manager.py
@@ -172,6 +172,9 @@ class Manager(object):
 
     def only(self, *args, **kwargs):
         return self.get_query_set().only(*args, **kwargs)
+    
+    def exists(self, *args, **kwargs):
+        return self.get_query_ste().exists(*args, **kwargs)
 
     def _insert(self, values, **kwargs):
         return insert_query(self.model, values, **kwargs)
diff --git a/django/db/models/query.py b/django/db/models/query.py
index 46a86fc..4d4a332 100644
--- a/django/db/models/query.py
+++ b/django/db/models/query.py
@@ -443,6 +443,12 @@ class QuerySet(object):
         self._result_cache = None
         return query.execute_sql(None)
     _update.alters_data = True
+    
+    def exists(self):
+        if self._result_cache is None:
+            c = self.query.clone()
+            return c.has_results()
+        return bool(self._result_cache)
 
     ##################################################
     # PUBLIC METHODS THAT RETURN A QUERYSET SUBCLASS #
diff --git a/django/db/models/sql/query.py b/django/db/models/sql/query.py
index 23f99e4..663aa1e 100644
--- a/django/db/models/sql/query.py
+++ b/django/db/models/sql/query.py
@@ -383,6 +383,16 @@ class BaseQuery(object):
             number = min(number, self.high_mark - self.low_mark)
 
         return number
+    
+    def has_results(self):
+        self.add_extra({'a': 1}, None, None, None, None, None)
+        self.add_fields(())
+        self.set_extra_mask(('a',))
+        self.set_aggregate_mask(())
+        self.clear_ordering()
+        results = self.execute_sql()
+        return bool(results)
+
 
     def as_sql(self, with_limits=True, with_col_aliases=False):
         """
diff --git a/django/forms/models.py b/django/forms/models.py
index cc43612..37fce68 100644
--- a/django/forms/models.py
+++ b/django/forms/models.py
@@ -319,9 +319,7 @@ class BaseModelForm(BaseForm):
             if self.instance.pk is not None:
                 qs = qs.exclude(pk=self.instance.pk)
 
-            # This cute trick with extra/values is the most efficient way to
-            # tell if a particular query returns any results.
-            if qs.extra(select={'a': 1}).values('a').order_by():
+            if qs.exists():
                 if len(unique_check) == 1:
                     self._errors[unique_check[0]] = ErrorList([self.unique_error_message(unique_check)])
                 else:
@@ -354,9 +352,7 @@ class BaseModelForm(BaseForm):
             if self.instance.pk is not None:
                 qs = qs.exclude(pk=self.instance.pk)
 
-            # This cute trick with extra/values is the most efficient way to
-            # tell if a particular query returns any results.
-            if qs.extra(select={'a': 1}).values('a').order_by():
+            if qs.exists():
                 self._errors[field] = ErrorList([
                     self.date_error_message(lookup_type, field, unique_for)
                 ])
diff --git a/docs/ref/models/querysets.txt b/docs/ref/models/querysets.txt
index efd7c54..66f0ba9 100644
--- a/docs/ref/models/querysets.txt
+++ b/docs/ref/models/querysets.txt
@@ -1114,6 +1114,12 @@ Aggregation <topics-db-aggregation>`.
 
 .. _field-lookups:
 
+``exists()``
+~~~~~~~~~~~~
+
+Returns whether or not there are any items in the ``QuerySet``.  This will
+perform the query in the simplest way possible.
+
 Field lookups
 -------------
 